INCLUDE	donnees.asm
EXTRN	AffBalle : FAR
EXTRN	effet : FAR 
EXTRN	verifBrique : FAR
EXTRN	decvie : FAR
public DepBalle
DeplaceBalle SEGMENT 
Assume CS:DeplaceBalle,DS:DATA,SS:Pile
DepBalle	PROC FAR		;Pour deplacer la balle  chaque tour
	push 	BP
	mov 	BP,SP
	push	AX,BX,CX,DX
	mov	AX,x		;coordonnes du centre de la balle initialement
	mov	BX,y		
	mov	CX,decx		;deplacements elementaires de la balle initialement
	mov	DX,decy
	cmp	AX,192
	jnz 	testDG
	push 	AX
	mov	AX,positionbarre1
	mov 	barresauv,AX
	pop 	AX
testDG:	cmp	AX,317-RAYON	;on regarde si la balle touche le bord Droit
	jae	testHB_D
	cmp	AX,3+RAYON	;sinon on regarde si la balle touche le bord Gauche
	jbe 	testHB_G
testHB:	cmp	BX,197-RAYON	;on regarde si la balle touche le bord Bas dans le cas ou la 					;balle ne touche 
	jae	testBarr	
	cmp	BX,21+RAYON	;on regarde sinon si la balle touche le bord Haut
	jbe	rebonH
testBrik:cmp	AX,55-RAYON	;on compare la position de la balle avec le bord gauche du pav de briques
	jae	suite1
	jmp	paRebon
suite1:	cmp 	AX,265+RAYON	;comparaison avec le bord droit du pav
	jbe	suite2
	jmp	paRebon
suite2:	cmp	AX,80-RAYON	;comparaison avec le bas du pav
	jae 	suite3
	jmp	paRebon
suite3:	cmp	AX,50+RAYON	;comparaison avec le haut du pav
	jmp	paRebon		
paRebon:jmp	continu		;cas ou la balle ne touche rien
testHB_D:cmp	BX,197-RAYON	;cas ou la balle est dans le coin Bas Droit
	jae	testBarC
	cmp	BX,21+RAYON	;cas ou la balle est dans le coin Haut Droit
	jbe	coin
	jmp	rebonCot	;cas ou la balle touche le bord Droit
testHB_G:cmp	BX,197-RAYON	;cas ou la balle est dans le coin Bas Gauche
	jae 	testBarC
	cmp	BX,21+RAYON	;cas ou la balle est dans le coin Haut Gauche
	jbe	coin
	jmp	rebonCot	;cas ou la balle touche le bord Gauche
testBarC:mov	DX,offset bip	;ca bippe si la balle touche un bord et la barre en meme temps
	mov	ah,09h
	int	21h
	pop	DX,AX
	jmp	continu		
	cmp	AX,positionbarre1	;on regarde si la balle touche la barre ou non par 					;rapport a l'extremite Gauche
	jb	perdu
	cmp	AX,finbarre1	;on regarde si la balle touche la barre ou non par rapport a 					;l'extremite Droite
	ja	perdu
	jmp	rebonB		
testBarr:cmp	AX,positionbarre1	;on regarde si la balle touche la barre ou non par 					;rapport a l'extremite Gauche
	jb	perdu
	cmp	AX,finbarre1	;on regarde si la balle touche la barre ou non par rapport a 					;l'extremite Droite
	ja	perdu
	jmp	rebonB			;les differents cas possibles pour les rebonds
rebonH:	neg	DX		;la balle rebondit en Haut , on inverse donc DX(mvt selon l'axe 				;y)
	push	AX,DX
	jmp	son
rebonCot:neg	CX		;la balle rebondit sur un Cote , on inverse donc CX(mvt 					;selon l'axe x)	
	push	AX,DX
	jmp 	son
coin:	neg	DX		;la balle rebondit dans un Coin donc on inverse les valeurs de DX 				;et AX
	neg	CX		;car le mvt est selon les deux axes x et y
	jmp	son
rebonB:	call 	effet
	jmp	continu
son:	mov	DX,offset bip	;ca bippe si la balle touche un bord
	mov	ah,09h
	int	21h
	pop	DX,AX
	jmp	continu		
continu:mov 	decx,CX
	mov 	decy,DX
	call 	verifbrique
	add	AX,CX		;on applique les nouvelles coordonnes de la balle aux variables 				;AX et DX 
	mov	x,AX		;apres avoir ajoute aux anciennes valeurs de x et y les valeurs 				;actuelles des
	add	BX,DX		;deplacements elementaires decx et decy
	mov	y,BX
	mov	decx,CX
	mov	decy,DX
	jmp 	fin
perdu:	mov 	balleperdue,1
	call 	decvie
	jmp	fin
fin:	pop	AX,BX,CX,DX,BP	;fin de la procedure : on depile
	ret
DepBalle ENDP
DeplaceBalle ENDS
END
