INCLUDE donnees.asm		;Projet AO & SE ASI3 2001/2002

public effet 

Assume cs:fx, ds:data, ss:pile

fx SEGMENT

effet PROC FAR  		; procedure gerant l'effet sur la balle
push BX				;Dans ce fichier, CX contient decx et DX contient decy

push AX,DX
mov dx,offset bip		;bruit du rebond
mov ah,09h
int 21h
pop DX,AX

neg DX				;on inverse la progression de la balle en y pour la reflexion

mov BX,positionbarre1		;on compare les positions de la raquette
sub BX,barresauv
cmp BX,0			; si la raquette est immobile
je fin				; rebond normal
ja positif			;la raquette s'est deplace vers la droite
jb negatif			; la raquette s'est dplace vers la gauche

positif:mov CX,decx
	cmp CX,0		;on regarde le signe du decalage en x
	ja memesens		;si ce decalage est positif, la balle va dans le meme sens que la barre
	jb senscontraire 	;sinon elle se deplace dans l'autre sens
negatif:mov CX,decx
	cmp CX,0
	ja senscontraire
	jb memesens
	
jmp fin

;si la barre et la balle vont dans le meme sens
memesens:
	mov BX,vitesse
	cmp BX,vitessemax	;on compare si la vitesse de la balle est max
	jbe cont		; si oui, la balle ne peut etre accelere
	mov BX,vitessemax	; on accelere la balle
	mov vitesse,BX
cont:	cmp CX,-300		;on regarde si le decalage en x est compris entre -50 et 50
	jbe fin
	cmp CX,300
	jae fin
	shl CX,1		;si non on multiplie par 32 ce decalage
	shl CX,1
	shl CX,1
	shl CX,1
	shl CX,1
	jmp fin


;si la barre et la balle ne vont pas dans le meme sens
senscontraire:
	mov BX,vitesse
	cmp BX,vitessepet 	;si la vitesse est minimum
	jae cont2
 	mov BX,vitessepet	;sinon on ralentit la balle
 	mov vitesse,BX
cont2:	cmp CX,-1		;si le decalage en x vaut -1 ou 1
	jb divise		;on ne fait rien
	cmp CX,1
	ja divise
	jmp fin
divise: shr CX,1		; sinon on divise par 32 le decalage en x
	shr CX,1		; pour accentuer le rebond
	shr CX,1
	shr CX,1
	shr CX,1
	jmp fin
	
fin: pop BX

ret
effet ENDP
fx ENDS
END 